# 
#
#
#
#
import sys

import numpy as np
import pyNN.nest as sim
import cPickle as pickle
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from stableBumpClass import StableBump

#
def init():
    print 'bob', neal.DELAY
    sim.setup(timestep=neal.DELAY,min_delay=neal.DELAY,
                    max_delay=neal.DELAY, debug=0)


#--main
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 6):
	t  = int(args[1])
	exw = float(args[2])
	inw = float(args[3])
	rMin = int(args[4])
	rMax = int(args[5])
	#exd = str(args[3])	
	#ind = str(args[4])

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
stableBump = StableBump(neal,fsa)

init()

neurons = 100
cellClass=sim.IF_cond_exp
cellParams=fsa.CELL_PARAMS
exWindow = 2
inWindow = 4
tempPop = stableBump.stableBump(neurons,cellClass,cellParams,2,4,exw,inw)
tempPop.record(['spikes','v','gsyn_exc','gsyn_inh'])

#TEST
source0 = stableBump.createTwoInputs()
spikeSource = stableBump.createTwoInputs()

if (t == 4):
    for i in range(rMin, rMax):
	stableBump.turnOnCellFromSpikeSource(spikeSource[0],tempPop,i)

if (t == 3):
    for i in range (25,50):    
        wta.turnOnCellFromSpikeSource(spikeSource[0],tempPop,i)

if (t == 2):
    for i in range (5,95):    
        wta.turnOnCellFromSpikeSource(spikeSource[0],tempPop,i)

elif (t == 1):
    for i in range (47,50):    
        wta.turnOnCellFromSpikeSource(spikeSource[1],tempPop,i)

print t

neal.nealApplyProjections()
sim.run(1000)
sim.end()

tempPop.write_data("outputs/network-2-4/splittingDynamics/popTemp-{}-{}-{}-{}-{}-S.pkl".format(t,exw,inw,rMin,rMax),'spikes')
tempPop.write_data("outputs/network-2-4/splittingDynamics/popTemp-{}-{}-{}-{}-{}-V.pkl".format(t,exw,inw,rMin,rMax),'v')
tempPop.write_data("outputs/network-2-4/splittingDynamics/popTemp-{}-{}-{}-{}-{}-E.pkl".format(t,exw,inw,rMin,rMax),'gsyn_exc')
tempPop.write_data("outputs/network-2-4/splittingDynamics/popTemp-{}-{}-{}-{}-{}-I.pkl".format(t,exw,inw,rMin,rMax),'gsyn_inh')

