
#  This reads the weights in, then tests the temperature retrieved
#  from the semantics warm coffee.
#
import pyNN.nest as sim
from nealCoverClass import NealCoverFunctions
from stateMachineClass import FSAHelperFunctions
from hotCoffeeTopologyClass import HotCoffeeClass

#a bit cheeky.  Should get them from hotCoffeeClass
COFFEE = 0
COKE = 1
COLD = 2
WARM = 3
HOT = 4

def createOneInputAndStop():
    inputSpikeTimes0 = [25.0] #on

    stopSpikeTimes = [300.0]
	    
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
					   label='inputSpikes_0')

    stopSpikeArray= {'spike_times': [stopSpikeTimes]}
    stopSpikeGen=sim.Population(1,sim.SpikeSourceArray,stopSpikeArray,
					   label='stopSpikes')
    return[spikeGen0,stopSpikeGen]



#--main
#Present an example of all the warm coffee pair.

#args = sys.argv
Duration = 1000 #this is changed for longer runs for merging streams

simName = "nest"
spinnVersion = -1
neal = NealCoverFunctions(simName,sim,spinnVersion)
fsa = FSAHelperFunctions(simName,sim,neal,spinnVersion)
hotCoffeeTopology = HotCoffeeClass(simName,sim,neal,fsa,spinnVersion)

hotCoffeeTopology.makeHotCoffeeTopologyNoOvercome()
hotCoffeeTopology.buildHotCoffeeTopology()
hotCoffeeTopology.connectSemanticBeveragesToTemps()
hotCoffeeTopology.readSemanticTempsToTemps()

pop = hotCoffeeTopology.getSemanticsNeurons()
inputPop = hotCoffeeTopology.getTemperatureBumpNeurons()

#TEST 
spikeSource = createOneInputAndStop()
inhWeight = 2.5

#hotCoffeeTopology.stopFullTopologyFromSpikeSource(spikeSource[1],inhWeight)

fsa.turnOnStateFromSpikeSource(spikeSource[0],pop, WARM )
fsa.turnOnStateFromSpikeSource(spikeSource[0],pop, COFFEE)

neal.nealApplyProjections()
sim.run(Duration)
sim.end()

hotCoffeeTopology.printTopologySpikes("outputs/noMergeTest")
