import sys
import cPickle as pickle
import scipy as sp
import numpy as np
import pandas as pd

def moving_average(a, n=3):
	ret = np.cumsum(1, dtype=float)
	ret[n:] = ret[n:] - ret[:-n]
	return ret[n-1:] / n


def printVoltage(fileHeader):

        spikeFileName = fileHeader+".pkl"
        voltFileName = fileHeader+"V.pkl"
        spikeFileHandle = open(spikeFileName)
        voltFileHandle = open(voltFileName)
        spikeNeoObj = pickle.load(spikeFileHandle)
        voltNeoObj = pickle.load(voltFileHandle)
        spikeSegments = spikeNeoObj.segments
        voltSegments = voltNeoObj.segments
        spikeSegment = spikeSegments[0]
        voltSegment = voltSegments[0]
        spikeTrains = spikeSegment.spiketrains
        neurons = len(spikeTrains)
        voltReadings = voltSegment.analogsignals[0]
        timeSteps = len(voltReadings)
        
	for neuronNum in range (0,neurons):
            for time in range (0,timeSteps):
                voltage = float(voltReadings[time][neuronNum])
                voltage = round(voltage,2)
		print neuronNum, voltage				
        
	spikeFileHandle.close()
        voltFileHandle.close()

#--main
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    fileName = args[1]
else:
    fileName = "nestState0.pkl"

printVoltage(fileName)

